MODULE ArrayedList ;

CONST max_size : INTEGER = 1000 ;

TYPE index = [-1..max_size] ;

VAR  current, last : index ;
     store : ARRAY index OF INTEGER ;


PROCEDURE Init() =
BEGIN
    current := 0 ;
    last := -1 ;
END Init ;


PROCEDURE ToFirst() =
BEGIN
    current := 0 ;
END ToFirst ;


PROCEDURE ToLast() =
BEGIN
    current := last ;
END ToLast ;


PROCEDURE IsAfter() : BOOLEAN =
BEGIN
    RETURN current > last ;
END IsAfter ;


PROCEDURE IsBefore() : BOOLEAN =
BEGIN
    RETURN current < 0 ;
END IsBefore ;


PROCEDURE Forth() =
BEGIN
    <* ASSERT NOT IsAfter() *>
    INC(current) ;
END Forth ;


PROCEDURE Back() =
BEGIN
    <* ASSERT NOT IsBefore() *>
    DEC(current) ;
END Back ;


PROCEDURE Get() : INTEGER =
BEGIN
    <* ASSERT NOT (IsBefore() OR IsAfter()) *>

    RETURN store[current] ;
END Get ;

PROCEDURE Set(item: INTEGER) =
BEGIN
    <* ASSERT NOT (IsBefore() OR IsAfter()) *>

    store[current] := item ;
END Set ;


PROCEDURE Append(item : INTEGER) =
BEGIN
    <* ASSERT last < max_size *>

    INC(last) ;
    store[last] := item ;
END Append ;


PROCEDURE InsertBefore(item : INTEGER) =
VAR i : index ;
BEGIN
    <* ASSERT last < max_size *>
    <* ASSERT NOT IsBefore() *>

    FOR i := last TO current BY -1 DO
	store[i+1] := store[i] ;
    END ;
    INC(last) ;
    store[current] := item ;
END InsertBefore ;


PROCEDURE Delete() = 
VAR i : index ;
BEGIN
    <* ASSERT NOT (IsBefore() OR IsAfter()) *>

    FOR i := current TO last - 1 DO
        store[i] := store[i+1] ;
    END ;
    DEC(last) ;
END Delete ;

BEGIN
END ArrayedList .
