MODULE Traversal ;

IMPORT IO, Stack, Queue ;
FROM SearchTree IMPORT Node, root ;


PROCEDURE Visit(n : Node) =
BEGIN
    IO.PutInt(n^.key) ;
    IO.Put("\n") ;
END Visit ;


PROCEDURE TraversePreOrder() =
VAR n : Node ;
BEGIN
    Stack.Push(Stack.Item{root, TRUE}) ;
    WHILE NOT Stack.IsEmpty() DO
        n := Stack.Pop().node ;
        IF n # NIL THEN 
            Visit(n) ;
            Stack.Push(Stack.Item{n^.right, TRUE}) ;
            Stack.Push(Stack.Item{n^.left,  TRUE}) ;
        END ;
    END ;
END TraversePreOrder ;


PROCEDURE TraverseInOrder() =
VAR s : Stack.Item ;
BEGIN
    Stack.Push(Stack.Item{root, TRUE}) ;
    WHILE NOT Stack.IsEmpty() DO
        s := Stack.Pop() ;
        IF s.node # NIL THEN
            IF s.flag THEN
                Stack.Push(Stack.Item{s.node, FALSE}) ;
                Stack.Push(Stack.Item{s.node^.left, TRUE}) ;
            ELSE
                Visit(s.node) ;
                Stack.Push(Stack.Item{s.node^.right, TRUE}) ;
            END ;
        END ;
    END ;
END TraverseInOrder ;


PROCEDURE TraversePostOrder() =
VAR s : Stack.Item ;
BEGIN
    Stack.Push(Stack.Item{root, TRUE}) ;
    WHILE NOT Stack.IsEmpty() DO
        s := Stack.Pop() ;
        IF s.node # NIL THEN
            IF s.flag THEN
                Stack.Push(Stack.Item{s.node, FALSE}) ;
                Stack.Push(Stack.Item{s.node^.right, TRUE}) ;
                Stack.Push(Stack.Item{s.node^.left, TRUE}) ;
            ELSE (* s.flag = 1 *)
                Visit(s.node) ;
            END ;
        END ;
    END ;
END TraversePostOrder ;


PROCEDURE TraverseLevelOrder() =
VAR n : Node ;
BEGIN
    Queue.Put(root) ;
    WHILE NOT Queue.IsEmpty() DO
        n := Queue.Get() ;
        IF n # NIL THEN
            Visit(n) ;
            Queue.Put(n^.left) ;
            Queue.Put(n^.right) ;
        END ;
    END ;
END TraverseLevelOrder ;


BEGIN
END Traversal .
